//
//  ModelFrame.m
//  AutoTableView
//
//  Created by Zhichao Ma on 2017/8/15.
//  Copyright © 2017年 Zhichao Ma. All rights reserved.
//

#import "ModelFrame.h"
#import "QuestionModel.h"
#import "AnswerItemModel.h"
#define T_A_Margin 20

#define A_A_Margin 10

#define Top_Margin 10

#define Bottom_Margin 10

// 左侧留20的空白，20的标签位置
#define Lift_Margin 40

#define Right_Margin 20

@interface ModelFrame ()

@property (nonatomic, assign)CGRect titleFrame;

@property (nonatomic, assign) CGRect answerFrame;

@property (nonatomic, strong) NSArray *subAnswerFrames;

@property (nonatomic, assign) CGFloat cellH;

@end

@implementation ModelFrame

-(void)setAutoModel:(QuestionModel *)autoModel{
    _autoModel = autoModel;
    // 标题
    NSString *title = autoModel.title;
    
    UIFont *font = [UIFont systemFontOfSize:15];
    
    CGSize titleSize = [self sizeWithTitle:title font:font];
    
    _titleFrame = CGRectMake(Lift_Margin, Top_Margin, titleSize.width, titleSize.height);
    
    // 答案组。1.答案的字体
    UIFont *answerFont = [UIFont systemFontOfSize:13];
    // 2.前一个View的最大Y值
    CGFloat proBottom = CGRectGetMaxY(_titleFrame);
    
    NSMutableArray *subAnswerArr = [NSMutableArray arrayWithCapacity:5];

    for (int index = 0; index < autoModel.answers.count; index ++) {
        AnswerItemModel *answer = autoModel.answers[index];
        
        CGSize size = [self sizeWithTitle:answer.answer font:answerFont];
        CGRect rect;
        
        if (index == 0) {
            
            rect = CGRectMake(Lift_Margin, proBottom + T_A_Margin, size.width, size.height);
        }else{
            rect = CGRectMake(Lift_Margin, proBottom + A_A_Margin, size.width, size.height);
        }
        
        [subAnswerArr addObject:[NSValue valueWithCGRect:rect]];
        
        proBottom = CGRectGetMaxY(rect);
    }
    
    _answerFrame = CGRectMake(Lift_Margin, CGRectGetMaxY(_titleFrame) + T_A_Margin, Width - Lift_Margin - Right_Margin, proBottom - CGRectGetMaxY(_titleFrame) - T_A_Margin);
    
    _subAnswerFrames = subAnswerArr.copy;
    
    _cellH = proBottom + Bottom_Margin;
}

-(CGSize)sizeWithTitle:(NSString *)title font:(UIFont *)font{
    
    return [title boundingRectWithSize:CGSizeMake(Width - Lift_Margin - Right_Margin, CGFLOAT_MAX) options:NSStringDrawingTruncatesLastVisibleLine|NSStringDrawingUsesLineFragmentOrigin|NSStringDrawingUsesFontLeading attributes:@{NSFontAttributeName: font} context:nil].size;
}

@end
