//
//  QuestionModel.m
//  AutoTableView
//
//  Created by Zhichao Ma on 2017/8/17.
//  Copyright © 2017年 Zhichao Ma. All rights reserved.
//

#import "QuestionModel.h"
#import "AnswerItemModel.h"
#import <objc/runtime.h>
@implementation QuestionModel

+(instancetype)questionModelWithDic:(NSDictionary *)dic{
    return [[self alloc]initWithDis:dic];
}
-(instancetype)initWithDis:(NSDictionary *)dic{
    self =[super init];
    if (self) {
        NSArray *array = [self propertys];
        
        [array enumerateObjectsUsingBlock:^(id  _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {
            NSString *key = obj;
            if ([key isEqualToString:@"answers"] && dic[key]) {
                NSArray *arr = dic[key];
                NSMutableArray *mArr = [NSMutableArray arrayWithCapacity:4];
                for (NSDictionary *dic in arr) {
                    AnswerItemModel *item = [AnswerItemModel answerItemWithDic:dic];
                    [mArr addObject:item];
                }
                [self setValue:mArr.copy forKey:key];
                
            }else if (dic[key]){
                [self setValue:dic[key] forKey:key];
            }
        }];
    }
    return self;
}
-(void)setValue:(id)value forUndefinedKey:(NSString *)key{
    
}
-(NSArray *)propertys{
    unsigned int count;
    
    objc_property_t *ptr_property = class_copyPropertyList(self.class, &count);
    
    NSMutableArray *array = [NSMutableArray array];
    
    for (int i = 0; i < count; i++) {
        objc_property_t property = ptr_property[i];
        
        const char *name = property_getName(property);
        
        NSString *propertyName = [[NSString alloc]initWithUTF8String:name];
        
        [array addObject:propertyName];
    }
    return array.copy;
}
@end
