//
//  ViewController.m
//  AutoTableView
//
//  Created by Zhichao Ma on 2017/8/15.
//  Copyright © 2017年 Zhichao Ma. All rights reserved.
//

#import "ViewController.h"
#import "AutoTableView.h"
#import "ModelFrame.h"
#import "SDChatMessageConst.h"
#import "QuestionModel.h"

@interface ViewController ()
@property (nonatomic, strong) NSArray *dbArray;

@property (nonatomic, strong) NSMutableArray *dataArr;

@property (nonatomic, strong) AutoTableView *tableView;

@end

@implementation ViewController

-(NSArray *)dbArray{
    if (!_dbArray ) {
//        NSMutableArray *mDbArray = [NSMutableArray arrayWithCapacity:5];
        
        NSString *path = [[NSBundle mainBundle]pathForResource:@"Answer.plist" ofType:nil];
        NSArray *answerArr = [NSArray arrayWithContentsOfFile:path];
        
        _dbArray = answerArr;
    }
    
    return _dbArray;
}
-(NSMutableArray *)dataArr{
    if (!_dataArr) {
        _dataArr = [NSMutableArray arrayWithCapacity:1];
        NSDictionary *dic = self.dbArray[arc4random()%self.dbArray.count];
  
        QuestionModel *model = [QuestionModel questionModelWithDic:dic];
        
        // 转化为frameModel
        ModelFrame *frame = [[ModelFrame alloc]init];
        frame.autoModel = model;
        
        [_dataArr addObject:frame];
    }
    
    return _dataArr;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    
    AutoTableView *tableView = [[AutoTableView alloc]initWithFrame:self.view.bounds style:UITableViewStyleGrouped];
    [self.view addSubview:tableView];
    
    _tableView = tableView;
    
    tableView.dataArray = self.dataArr;
    [tableView reloadData];
    
    [[NSNotificationCenter defaultCenter]addObserver:self selector:@selector(selectitem:) name:SelectItemNotification object:nil];
    [[NSNotificationCenter defaultCenter]addObserver:self selector:@selector(deleteItem:) name:DeleteItemNotification object:nil];
}
-(void)selectitem:(NSNotification *)notifi{
    
    NSArray *arr = notifi.object;
    ModelFrame *model = arr[0];
    NSNumber *num = arr[1];
    QuestionModel *question = model.autoModel;
    AnswerItemModel *item = question.answers[num.integerValue];
    [question setValue:@[item] forKey:@"answers"];
    model.autoModel = question;
    model.select = YES;
    
    [_tableView.dataArray replaceObjectAtIndex:self.dataArr.count -1 withObject:model];
    self.dataArr = _tableView.dataArray;
    
    // 添加的数据
    NSDictionary *dic = self.dbArray[arc4random()%self.dbArray.count];
    
    QuestionModel *questionModel = [QuestionModel questionModelWithDic:dic];
    
    // 转化为frameModel
    ModelFrame *frame = [[ModelFrame alloc]init];
    frame.autoModel = questionModel;

    [_dataArr addObject:frame];
//
    [_tableView addItem];

}

-(void)deleteItem:(NSNotification *)notifi{
    NSNumber *value = notifi.object;
    
    [_tableView deleteItemFrom:[value integerValue]];
}
- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


@end
